#import <objc/objc.h>
#import <objc/objc-api.h>

retval_t objc_msg_sendv_for_forth(arglist_t arg)
{
  unsigned long *p = (unsigned long *)arg->arg_ptr;
  int i, cnt = (int)p[0];
  id obj = (id) p[1];
  SEL sel = (SEL) p[2];

  Method *m = class_get_instance_method (obj->class_pointer, sel);

#if 0

  printf("\nIn %s: ", __FUNCTION__);
  printf("\nmessage name: %s ", sel_get_name(sel));
  printf("\nmessage type: %s ", m->method_types);
#endif

  for(i = 0; i < cnt; i++)
	p[i] = p[i+1];

#if 0
  for(i = 0; i < cnt; i++)
	printf("\n%dth: %x", i, p[i]);
#endif

  /*
   * method that takes variable arguments usually have a method_type
   * like @12@0:4@8.
   * so, if we use objc_msg_sendv function in libobjc
   * argument count always becomes 12. This is not what we want.
   * Therefore, as a workaround, this function receives
   * argument count(of course, including id, and SEL also) from 'arg'
argument
   * and pass the correct argument space size to the corresponding
method.
   * by multiplying by 4.
   */
  return __builtin_apply((apply_t)m->method_imp, arg, cnt*4);
}
